"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DynamoDataOperation = void 0;

var _errors = require("./../helpers/errors.js");

var _joi = _interopRequireDefault(require("@hapi/joi"));

var _dynamodbAutoMarshaller = require("@aws/dynamodb-auto-marshaller");

var _baseJoiHelper = require("../core/base-joi-helper.js");

var _baseMixins = _interopRequireDefault(require("../core/base-mixins.js"));

var _baseSchema = require("./base-schema.js");

var _dynamoManageTable = require("./dynamo-manage-table.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function createTenantSchema(schemaMapDef) {
  return _joi["default"].object().keys(schemaMapDef).keys(_baseSchema.coreSchemaDefinition);
}

var DynamoDataOperation = /*#__PURE__*/function (_BaseMixins) {
  _inherits(DynamoDataOperation, _BaseMixins);

  var _super = _createSuper(DynamoDataOperation);

  //
  //
  function DynamoDataOperation(_ref) {
    var _this;

    var dynamoDb = _ref.dynamoDb,
        schemaDef = _ref.schemaDef,
        dynamoDbClient = _ref.dynamoDbClient,
        secondaryIndexOptions = _ref.secondaryIndexOptions,
        featureIdentityValue = _ref.featureIdentityValue,
        baseTableName = _ref.baseTableName,
        strictRequiredFields = _ref.strictRequiredFields,
        dataKeyGenerator = _ref.dataKeyGenerator;

    _classCallCheck(this, DynamoDataOperation);

    _this = _super.call(this);

    _defineProperty(_assertThisInitialized(_this), "here_partitionKeyFieldName", "id");

    _defineProperty(_assertThisInitialized(_this), "here_sortKeyFieldName", "featureIdentity");

    _defineProperty(_assertThisInitialized(_this), "here_dynamoDbClient", void 0);

    _defineProperty(_assertThisInitialized(_this), "here_dynamoDb", void 0);

    _defineProperty(_assertThisInitialized(_this), "here_dataKeyGenerator", void 0);

    _defineProperty(_assertThisInitialized(_this), "here_schema", void 0);

    _defineProperty(_assertThisInitialized(_this), "here_marshaller", void 0);

    _defineProperty(_assertThisInitialized(_this), "here_tableFullName", void 0);

    _defineProperty(_assertThisInitialized(_this), "here_strictRequiredFields", void 0);

    _defineProperty(_assertThisInitialized(_this), "here_featureIdentityValue", void 0);

    _defineProperty(_assertThisInitialized(_this), "here_secondaryIndexOptions", void 0);

    _defineProperty(_assertThisInitialized(_this), "here_tableManager", void 0);

    _this.here_dynamoDb = dynamoDb;
    _this.here_dynamoDbClient = dynamoDbClient;
    _this.here_dataKeyGenerator = dataKeyGenerator;
    _this.here_schema = createTenantSchema(schemaDef);
    _this.here_tableFullName = baseTableName;
    _this.here_marshaller = new _dynamodbAutoMarshaller.Marshaller({
      onEmpty: "omit"
    });
    _this.here_featureIdentityValue = featureIdentityValue;
    _this.here_secondaryIndexOptions = secondaryIndexOptions;
    _this.here_strictRequiredFields = strictRequiredFields;
    return _this;
  }

  _createClass(DynamoDataOperation, [{
    key: "getTableManager",
    value: function getTableManager() {
      if (!this.here_tableManager) {
        this.here_tableManager = new _dynamoManageTable.DynamoManageTable({
          dynamoDb: this.here_dynamoDb,
          secondaryIndexOptions: this.here_secondaryIndexOptions,
          tableFullName: this.here_tableFullName,
          partitionKeyFieldName: this.here_partitionKeyFieldName,
          sortKeyFieldName: this.here_sortKeyFieldName
        });
      }

      return this.here_tableManager;
    }
  }, {
    key: "_dynamoDbClient",
    value: function _dynamoDbClient() {
      return this.here_dynamoDbClient();
    }
  }, {
    key: "_dynamoDb",
    value: function _dynamoDb() {
      return this.here_dynamoDb();
    }
  }, {
    key: "generateDynamoTableKey",
    value: function generateDynamoTableKey() {
      return this.here_dataKeyGenerator();
    }
  }, {
    key: "_getLocalVariables",
    value: function _getLocalVariables() {
      return {
        partitionKeyFieldName: this.here_partitionKeyFieldName,
        sortKeyFieldName: this.here_sortKeyFieldName,
        //
        featureIdentityValue: this.here_featureIdentityValue,
        //
        tableFullName: this.here_tableFullName,
        secondaryIndexOptions: this.here_secondaryIndexOptions,
        strictRequiredFields: this.here_strictRequiredFields
      };
    }
  }, {
    key: "_getBaseObject",
    value: function _getBaseObject(_ref2) {
      var _dataMust;

      var dataId = _ref2.dataId;

      var _this$_getLocalVariab = this._getLocalVariables(),
          partitionKeyFieldName = _this$_getLocalVariab.partitionKeyFieldName,
          sortKeyFieldName = _this$_getLocalVariab.sortKeyFieldName,
          featureIdentityValue = _this$_getLocalVariab.featureIdentityValue;

      var dataMust = (_dataMust = {}, _defineProperty(_dataMust, partitionKeyFieldName, dataId), _defineProperty(_dataMust, sortKeyFieldName, featureIdentityValue), _dataMust);
      return dataMust;
    }
  }, {
    key: "_checkValidateMustBeAnObjectDataType",
    value: function _checkValidateMustBeAnObjectDataType(data) {
      if (!data || _typeof(data) !== "object") {
        throw new _errors.GenericDataError("Data MUST be valid object");
      }
    }
  }, {
    key: "_checkValidateStrictRequiredFields",
    value: function _checkValidateStrictRequiredFields(onDataObj) {
      this._checkValidateMustBeAnObjectDataType(onDataObj);

      var _this$_getLocalVariab2 = this._getLocalVariables(),
          strictRequiredFields = _this$_getLocalVariab2.strictRequiredFields;

      if (strictRequiredFields === null || strictRequiredFields === void 0 ? void 0 : strictRequiredFields.length) {
        var _iterator = _createForOfIteratorHelper(strictRequiredFields),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var field = _step.value;

            if (onDataObj[field] === null || onDataObj[field] === undefined) {
              throw new _errors.GenericDataError("Required field NOT defined");
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }
    }
  }, {
    key: "allCreateOneBase",
    value: function () {
      var _allCreateOneBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref3) {
        var data, _this$_getLocalVariab3, tableFullName, partitionKeyFieldName, dataId, baseData, dataMust, fullData, _yield$this$_allHelpV, validatedData, marshalled, params, result;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                data = _ref3.data;

                this._checkValidateStrictRequiredFields(data);

                _this$_getLocalVariab3 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab3.tableFullName, partitionKeyFieldName = _this$_getLocalVariab3.partitionKeyFieldName;
                dataId = data[partitionKeyFieldName];

                if (!dataId) {
                  dataId = this.generateDynamoTableKey();
                }

                baseData = {
                  createdAtDate: new Date().toISOString()
                };
                dataMust = this._getBaseObject({
                  dataId: dataId
                });
                fullData = _objectSpread(_objectSpread(_objectSpread({}, data), baseData), dataMust);
                _context.next = 10;
                return this._allHelpValidateMarshallAndGetValue(fullData);

              case 10:
                _yield$this$_allHelpV = _context.sent;
                validatedData = _yield$this$_allHelpV.validatedData;
                marshalled = _yield$this$_allHelpV.marshalled;
                params = {
                  TableName: tableFullName,
                  Item: marshalled
                };
                _context.next = 16;
                return this._dynamoDb().putItem(params).promise();

              case 16:
                result = validatedData;
                return _context.abrupt("return", result);

              case 18:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function allCreateOneBase(_x) {
        return _allCreateOneBase.apply(this, arguments);
      }

      return allCreateOneBase;
    }()
  }, {
    key: "withConditionPassed",
    value: function withConditionPassed(_ref4) {
      var item = _ref4.item,
          withCondition = _ref4.withCondition;

      if (item && (withCondition === null || withCondition === void 0 ? void 0 : withCondition.length)) {
        var isPassed = withCondition.every(function (_ref5) {
          var field = _ref5.field,
              equals = _ref5.equals;
          return item[field] !== undefined && item[field] === equals;
        });
        return isPassed;
      }

      return true;
    }
  }, {
    key: "allGetOneByIdBase",
    value: function () {
      var _allGetOneByIdBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref6) {
        var _Key;

        var dataId, withCondition, _this$_getLocalVariab4, partitionKeyFieldName, sortKeyFieldName, featureIdentityValue, tableFullName, params, result, item, isPassed;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                dataId = _ref6.dataId, withCondition = _ref6.withCondition;
                _this$_getLocalVariab4 = this._getLocalVariables(), partitionKeyFieldName = _this$_getLocalVariab4.partitionKeyFieldName, sortKeyFieldName = _this$_getLocalVariab4.sortKeyFieldName, featureIdentityValue = _this$_getLocalVariab4.featureIdentityValue, tableFullName = _this$_getLocalVariab4.tableFullName;
                this.allHelpValidateRequiredString({
                  QueryGetOnePartitionKey: dataId,
                  QueryGetOneSortKey: featureIdentityValue
                });
                params = {
                  TableName: tableFullName,
                  Key: (_Key = {}, _defineProperty(_Key, partitionKeyFieldName, dataId), _defineProperty(_Key, sortKeyFieldName, featureIdentityValue), _Key)
                };
                _context2.next = 6;
                return this._dynamoDbClient().get(params).promise();

              case 6:
                result = _context2.sent;
                item = result.Item;

                if (item) {
                  _context2.next = 10;
                  break;
                }

                return _context2.abrupt("return", null);

              case 10:
                isPassed = this.withConditionPassed({
                  withCondition: withCondition,
                  item: item
                });

                if (isPassed) {
                  _context2.next = 13;
                  break;
                }

                return _context2.abrupt("return", null);

              case 13:
                return _context2.abrupt("return", item);

              case 14:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function allGetOneByIdBase(_x2) {
        return _allGetOneByIdBase.apply(this, arguments);
      }

      return allGetOneByIdBase;
    }()
  }, {
    key: "allGetOneByIdProjectBase",
    value: function () {
      var _allGetOneByIdProjectBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref7) {
        var _Key2;

        var dataId, projectionAttributes, withCondition, _this$_getLocalVariab5, partitionKeyFieldName, sortKeyFieldName, featureIdentityValue, tableFullName, params, result, item, isPassed;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                dataId = _ref7.dataId, projectionAttributes = _ref7.projectionAttributes, withCondition = _ref7.withCondition;
                this.allHelpValidateRequiredString({
                  Get1DataId: dataId
                });
                _this$_getLocalVariab5 = this._getLocalVariables(), partitionKeyFieldName = _this$_getLocalVariab5.partitionKeyFieldName, sortKeyFieldName = _this$_getLocalVariab5.sortKeyFieldName, featureIdentityValue = _this$_getLocalVariab5.featureIdentityValue, tableFullName = _this$_getLocalVariab5.tableFullName;
                params = {
                  TableName: tableFullName,
                  Key: (_Key2 = {}, _defineProperty(_Key2, partitionKeyFieldName, dataId), _defineProperty(_Key2, sortKeyFieldName, featureIdentityValue), _Key2),
                  ProjectionExpression: projectionAttributes.join(", ").trim()
                };
                _context3.next = 6;
                return this._dynamoDbClient().get(params).promise();

              case 6:
                result = _context3.sent;
                item = result.Item;

                if (item) {
                  _context3.next = 10;
                  break;
                }

                return _context3.abrupt("return", null);

              case 10:
                isPassed = this.withConditionPassed({
                  withCondition: withCondition,
                  item: item
                });

                if (isPassed) {
                  _context3.next = 13;
                  break;
                }

                return _context3.abrupt("return", null);

              case 13:
                return _context3.abrupt("return", item);

              case 14:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function allGetOneByIdProjectBase(_x3) {
        return _allGetOneByIdProjectBase.apply(this, arguments);
      }

      return allGetOneByIdProjectBase;
    }()
  }, {
    key: "allUpdateOneDirectBase",
    value: function () {
      var _allUpdateOneDirectBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref8) {
        var data, _this$_getLocalVariab6, tableFullName, partitionKeyFieldName, dataId, dataMust, baseData, fullData, _yield$this$_allHelpV2, validatedData, marshalled, params, result;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                data = _ref8.data;

                this._checkValidateStrictRequiredFields(data);

                _this$_getLocalVariab6 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab6.tableFullName, partitionKeyFieldName = _this$_getLocalVariab6.partitionKeyFieldName;
                dataId = data[partitionKeyFieldName];

                if (dataId) {
                  _context4.next = 6;
                  break;
                }

                throw new _errors.GenericDataError("Update data requires sort key field value");

              case 6:
                dataMust = this._getBaseObject({
                  dataId: dataId
                });
                baseData = {
                  lastModifiedDate: new Date().toISOString()
                };
                fullData = _objectSpread(_objectSpread(_objectSpread({}, data), baseData), dataMust); //

                _context4.next = 11;
                return this._allHelpValidateMarshallAndGetValue(fullData);

              case 11:
                _yield$this$_allHelpV2 = _context4.sent;
                validatedData = _yield$this$_allHelpV2.validatedData;
                marshalled = _yield$this$_allHelpV2.marshalled;
                params = {
                  TableName: tableFullName,
                  Item: marshalled
                };
                _context4.next = 17;
                return this._dynamoDb().putItem(params).promise();

              case 17:
                result = validatedData;
                return _context4.abrupt("return", result);

              case 19:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function allUpdateOneDirectBase(_x4) {
        return _allUpdateOneDirectBase.apply(this, arguments);
      }

      return allUpdateOneDirectBase;
    }()
  }, {
    key: "allUpdateOneByIdBase",
    value: function () {
      var _allUpdateOneByIdBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(_ref9) {
        var dataId, data, withCondition, _this$_getLocalVariab7, tableFullName, partitionKeyFieldName, dataInDb, isPassed, dataMust, fullData, _yield$this$_allHelpV3, validatedData, marshalled, params, result;

        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                dataId = _ref9.dataId, data = _ref9.data, withCondition = _ref9.withCondition;

                this._checkValidateStrictRequiredFields(data);

                _this$_getLocalVariab7 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab7.tableFullName, partitionKeyFieldName = _this$_getLocalVariab7.partitionKeyFieldName;
                this.allHelpValidateRequiredString({
                  Update1DataId: dataId
                });
                _context5.next = 6;
                return this.allGetOneByIdBase({
                  dataId: dataId
                });

              case 6:
                dataInDb = _context5.sent;

                if (dataInDb && dataInDb[partitionKeyFieldName]) {
                  _context5.next = 9;
                  break;
                }

                throw new _errors.GenericDataError("Data does NOT exists");

              case 9:
                isPassed = this.withConditionPassed({
                  withCondition: withCondition,
                  item: dataInDb
                });

                if (isPassed) {
                  _context5.next = 12;
                  break;
                }

                throw new _errors.GenericDataError("Update condition failed");

              case 12:
                dataMust = this._getBaseObject({
                  dataId: dataInDb[partitionKeyFieldName]
                });
                fullData = _objectSpread(_objectSpread(_objectSpread({}, dataInDb), data), dataMust);
                _context5.next = 16;
                return this._allHelpValidateMarshallAndGetValue(fullData);

              case 16:
                _yield$this$_allHelpV3 = _context5.sent;
                validatedData = _yield$this$_allHelpV3.validatedData;
                marshalled = _yield$this$_allHelpV3.marshalled;
                params = {
                  TableName: tableFullName,
                  Item: marshalled
                };
                _context5.next = 22;
                return this._dynamoDb().putItem(params).promise();

              case 22:
                result = validatedData;
                return _context5.abrupt("return", result);

              case 24:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function allUpdateOneByIdBase(_x5) {
        return _allUpdateOneByIdBase.apply(this, arguments);
      }

      return allUpdateOneByIdBase;
    }()
  }, {
    key: "_allHelpValidateMarshallAndGetValue",
    value: function () {
      var _allHelpValidateMarshallAndGetValue2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(data) {
        var _this$here_schema$val, error, value, _getJoiValidationErro, msg, marshalledData;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _this$here_schema$val = this.here_schema.validate(data, {
                  stripUnknown: true
                }), error = _this$here_schema$val.error, value = _this$here_schema$val.value;

                if (!error) {
                  _context6.next = 4;
                  break;
                }

                msg = (_getJoiValidationErro = (0, _baseJoiHelper.getJoiValidationErrors)(error)) !== null && _getJoiValidationErro !== void 0 ? _getJoiValidationErro : "Validation error occured";
                throw new _errors.GenericDataError(msg);

              case 4:
                marshalledData = this.here_marshaller.marshallItem(value);
                _context6.next = 7;
                return Promise.resolve({
                  validatedData: value,
                  marshalled: marshalledData
                });

              case 7:
                return _context6.abrupt("return", _context6.sent);

              case 8:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function _allHelpValidateMarshallAndGetValue(_x6) {
        return _allHelpValidateMarshallAndGetValue2.apply(this, arguments);
      }

      return _allHelpValidateMarshallAndGetValue;
    }() //================================

  }, {
    key: "allExistsByIdBase",
    value: function () {
      var _allExistsByIdBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(dataId) {
        var _this$_getLocalVariab8, partitionKeyFieldName, data;

        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                this.allHelpValidateRequiredString({
                  Exist1DataId: dataId
                });
                _this$_getLocalVariab8 = this._getLocalVariables(), partitionKeyFieldName = _this$_getLocalVariab8.partitionKeyFieldName;
                _context7.next = 4;
                return this.allGetOneByIdProjectBase({
                  dataId: dataId,
                  projectionAttributes: [partitionKeyFieldName]
                });

              case 4:
                data = _context7.sent;

                if (!(data && data[partitionKeyFieldName])) {
                  _context7.next = 7;
                  break;
                }

                return _context7.abrupt("return", true);

              case 7:
                return _context7.abrupt("return", false);

              case 8:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function allExistsByIdBase(_x7) {
        return _allExistsByIdBase.apply(this, arguments);
      }

      return allExistsByIdBase;
    }()
  }, {
    key: "allQueryGetManyByConditionBase",
    value: function () {
      var _allQueryGetManyByConditionBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(_ref10) {
        var _result$mainResult;

        var paramOptions, result;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                paramOptions = _ref10.paramOptions;
                paramOptions.pagingParams = undefined;
                _context8.next = 4;
                return this.allQueryGetManyByConditionPaginateBase({
                  paramOptions: paramOptions
                });

              case 4:
                result = _context8.sent;

                if (!(result === null || result === void 0 ? void 0 : (_result$mainResult = result.mainResult) === null || _result$mainResult === void 0 ? void 0 : _result$mainResult.length)) {
                  _context8.next = 7;
                  break;
                }

                return _context8.abrupt("return", result.mainResult);

              case 7:
                return _context8.abrupt("return", []);

              case 8:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function allQueryGetManyByConditionBase(_x8) {
        return _allQueryGetManyByConditionBase.apply(this, arguments);
      }

      return allQueryGetManyByConditionBase;
    }()
  }, {
    key: "allQueryGetManyByConditionPaginateBase",
    value: function () {
      var _allQueryGetManyByConditionPaginateBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(_ref11) {
        var _paramOptions$partiti,
            _paramOptions$fields,
            _otherFilterExpressio,
            _paramOptions$pagingP,
            _this2 = this;

        var paramOptions, _this$_getLocalVariab9, tableFullName, sortKeyFieldName, partitionKeyFieldName, sortKeyQuery, sortKeyQueryData, filterHashSortKey, otherFilterExpression, otherExpressionAttributeValues, otherExpressionAttributeNames, filterOtherAttributes, params, hashKeyAndSortKey, paginationObjects, result;

        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                paramOptions = _ref11.paramOptions;
                _this$_getLocalVariab9 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab9.tableFullName, sortKeyFieldName = _this$_getLocalVariab9.sortKeyFieldName, partitionKeyFieldName = _this$_getLocalVariab9.partitionKeyFieldName; //

                if (paramOptions === null || paramOptions === void 0 ? void 0 : (_paramOptions$partiti = paramOptions.partitionSortKeyQuery) === null || _paramOptions$partiti === void 0 ? void 0 : _paramOptions$partiti.partitionKeyEquals) {
                  _context9.next = 4;
                  break;
                }

                throw new _errors.GenericDataError("Invalid Hash key value");

              case 4:
                if (sortKeyFieldName) {
                  _context9.next = 6;
                  break;
                }

                throw new _errors.GenericDataError("Bad query sort configuration");

              case 6:
                sortKeyQuery = {};
                sortKeyQueryData = paramOptions.partitionSortKeyQuery.sortKeyQuery;

                if (!sortKeyQueryData) {
                  _context9.next = 14;
                  break;
                }

                if (!sortKeyQueryData[sortKeyFieldName]) {
                  _context9.next = 13;
                  break;
                }

                sortKeyQuery = _defineProperty({}, sortKeyFieldName, sortKeyQueryData[sortKeyFieldName]);
                _context9.next = 14;
                break;

              case 13:
                throw new _errors.GenericDataError("Invalid Sort key value");

              case 14:
                filterHashSortKey = this.__helperDynamoFilterOperation({
                  queryDefs: _objectSpread(_objectSpread({}, sortKeyQuery), _defineProperty({}, partitionKeyFieldName, paramOptions.partitionSortKeyQuery.partitionKeyEquals)),
                  projectionFields: (_paramOptions$fields = paramOptions === null || paramOptions === void 0 ? void 0 : paramOptions.fields) !== null && _paramOptions$fields !== void 0 ? _paramOptions$fields : undefined
                }); //
                //

                otherFilterExpression = undefined;
                otherExpressionAttributeValues = undefined;
                otherExpressionAttributeNames = undefined;

                if (paramOptions === null || paramOptions === void 0 ? void 0 : paramOptions.query) {
                  filterOtherAttributes = this.__helperDynamoFilterOperation({
                    queryDefs: paramOptions.query,
                    projectionFields: null
                  });
                  otherExpressionAttributeValues = filterOtherAttributes.expressionAttributeValues;
                  otherExpressionAttributeNames = filterOtherAttributes.expressionAttributeNames;

                  if ((filterOtherAttributes === null || filterOtherAttributes === void 0 ? void 0 : filterOtherAttributes.filterExpression) && (filterOtherAttributes === null || filterOtherAttributes === void 0 ? void 0 : filterOtherAttributes.filterExpression.length) > 1) {
                    otherFilterExpression = filterOtherAttributes.filterExpression;
                  }
                }

                params = {
                  TableName: tableFullName,
                  KeyConditionExpression: filterHashSortKey.filterExpression,
                  ExpressionAttributeValues: _objectSpread(_objectSpread({}, otherExpressionAttributeValues), filterHashSortKey.expressionAttributeValues),
                  FilterExpression: (_otherFilterExpressio = otherFilterExpression) !== null && _otherFilterExpressio !== void 0 ? _otherFilterExpressio : undefined,
                  ExpressionAttributeNames: _objectSpread(_objectSpread({}, otherExpressionAttributeNames), filterHashSortKey.expressionAttributeNames)
                };

                if (filterHashSortKey === null || filterHashSortKey === void 0 ? void 0 : filterHashSortKey.projectionExpressionAttr) {
                  params.ProjectionExpression = filterHashSortKey.projectionExpressionAttr;
                }

                if ((paramOptions === null || paramOptions === void 0 ? void 0 : (_paramOptions$pagingP = paramOptions.pagingParams) === null || _paramOptions$pagingP === void 0 ? void 0 : _paramOptions$pagingP.orderDesc) === true) {
                  params.ScanIndexForward = false;
                }

                hashKeyAndSortKey = [partitionKeyFieldName, sortKeyFieldName];
                paginationObjects = _objectSpread({}, paramOptions.pagingParams);
                _context9.next = 26;
                return this.__helperDynamoQueryProcessor(_objectSpread({
                  dynamoDbClient: function dynamoDbClient() {
                    return _this2._dynamoDbClient();
                  },
                  params: params,
                  hashKeyAndSortKey: hashKeyAndSortKey
                }, paginationObjects));

              case 26:
                result = _context9.sent;
                return _context9.abrupt("return", result);

              case 28:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function allQueryGetManyByConditionPaginateBase(_x9) {
        return _allQueryGetManyByConditionPaginateBase.apply(this, arguments);
      }

      return allQueryGetManyByConditionPaginateBase;
    }()
  }, {
    key: "allBatchGetManyByHashAndSortKey",
    value: function () {
      var _allBatchGetManyByHashAndSortKey = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(_ref12) {
        var _this3 = this;

        var dataIds, fields, getRandom;
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                dataIds = _ref12.dataIds, fields = _ref12.fields;
                dataIds.forEach(function (sortKeyValue) {
                  _this3.allHelpValidateRequiredString({
                    BatchGetSortKey: sortKeyValue
                  });
                });

                getRandom = function getRandom() {
                  return ["rand", Math.round(Math.random() * 99999), Math.round(Math.random() * 88888), Math.round(Math.random() * 99)].join("");
                };

                return _context10.abrupt("return", new Promise(function (resolve, reject) {
                  var _this3$_getLocalVaria = _this3._getLocalVariables(),
                      tableFullName = _this3$_getLocalVaria.tableFullName,
                      partitionKeyFieldName = _this3$_getLocalVaria.partitionKeyFieldName,
                      sortKeyFieldName = _this3$_getLocalVaria.sortKeyFieldName,
                      featureIdentityValue = _this3$_getLocalVaria.featureIdentityValue;

                  var getArray = dataIds.map(function (dataId) {
                    var _params2;

                    var params01 = (_params2 = {}, _defineProperty(_params2, partitionKeyFieldName, {
                      S: dataId
                    }), _defineProperty(_params2, sortKeyFieldName, {
                      S: featureIdentityValue
                    }), _params2);
                    return params01;
                  });
                  var projectionExpression = undefined;
                  var expressionAttributeNames = undefined;

                  if (fields === null || fields === void 0 ? void 0 : fields.length) {
                    var _Object$keys;

                    var _fields = _toConsumableArray(fields);

                    expressionAttributeNames = {};

                    _fields.forEach(function (fieldName) {
                      if (typeof fieldName === "string") {
                        if (expressionAttributeNames) {
                          var attrKeyHash = "#attrKey".concat(getRandom(), "k").toLowerCase();
                          expressionAttributeNames[attrKeyHash] = fieldName;
                        }
                      }
                    });

                    if ((_Object$keys = Object.keys(expressionAttributeNames)) === null || _Object$keys === void 0 ? void 0 : _Object$keys.length) {
                      projectionExpression = Object.keys(expressionAttributeNames).join(",");
                    } else {
                      projectionExpression = undefined;
                      expressionAttributeNames = undefined;
                    }
                  }

                  var params = {
                    RequestItems: _defineProperty({}, tableFullName, {
                      Keys: _toConsumableArray(getArray),
                      ConsistentRead: true,
                      ProjectionExpression: projectionExpression,
                      ExpressionAttributeNames: expressionAttributeNames
                    })
                  };
                  var returnedItems = [];

                  var batchGetUntilDone = function batchGetUntilDone(err, data) {
                    if (err) {
                      var _returnedItems;

                      if ((_returnedItems = returnedItems) === null || _returnedItems === void 0 ? void 0 : _returnedItems.length) {
                        resolve(returnedItems);
                      } else {
                        reject(err.stack);
                      }
                    } else {
                      if (data === null || data === void 0 ? void 0 : data.Responses) {
                        var itemListRaw = data.Responses[tableFullName];
                        var itemList = itemListRaw.map(function (item) {
                          return _this3.here_marshaller.unmarshallItem(item);
                        });
                        returnedItems = [].concat(_toConsumableArray(returnedItems), _toConsumableArray(itemList));
                      }

                      if (data === null || data === void 0 ? void 0 : data.UnprocessedKeys) {
                        var _params = {
                          RequestItems: data.UnprocessedKeys
                        };
                        console.log({
                          dynamoBatchGetParams: _params
                        });

                        _this3._dynamoDb().batchGetItem(_params, batchGetUntilDone);
                      } else {
                        resolve(returnedItems);
                      }
                    }
                  };

                  _this3._dynamoDb().batchGetItem(params, batchGetUntilDone);
                }));

              case 4:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10);
      }));

      function allBatchGetManyByHashAndSortKey(_x10) {
        return _allBatchGetManyByHashAndSortKey.apply(this, arguments);
      }

      return allBatchGetManyByHashAndSortKey;
    }()
  }, {
    key: "allQuerySecondaryIndexBase",
    value: function () {
      var _allQuerySecondaryIndexBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(paramOption) {
        var result;
        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                paramOption.pagingParams = undefined;
                _context11.next = 3;
                return this.allQuerySecondaryIndexPaginateBase(paramOption);

              case 3:
                result = _context11.sent;

                if (!(result === null || result === void 0 ? void 0 : result.mainResult)) {
                  _context11.next = 6;
                  break;
                }

                return _context11.abrupt("return", result.mainResult);

              case 6:
                return _context11.abrupt("return", []);

              case 7:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function allQuerySecondaryIndexBase(_x11) {
        return _allQuerySecondaryIndexBase.apply(this, arguments);
      }

      return allQuerySecondaryIndexBase;
    }()
  }, {
    key: "allQuerySecondaryIndexPaginateBase",
    value: function () {
      var _allQuerySecondaryIndexPaginateBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(paramOption) {
        var _otherFilterExpressio2,
            _this4 = this;

        var _this$_getLocalVariab10, tableFullName, secondaryIndexOptions, indexName, partitionQuery, sortKeyQuery, fields, pagingParams, otherQuery, secondaryIndex, keyFieldName, sortFieldName, partitionSortKeyQuery, _this$__helperDynamoF, expressionAttributeValues, filterExpression, projectionExpressionAttr, expressionAttributeNames, otherFilterExpression, otherExpressionAttributeValues, otherExpressionAttributeNames, _otherAttr$filterExpr, otherAttr, params, orderDesc, hashKeyName, sortKeyName, hashKeyAndSortKey, result;

        return regeneratorRuntime.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _this$_getLocalVariab10 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab10.tableFullName, secondaryIndexOptions = _this$_getLocalVariab10.secondaryIndexOptions;

                if (secondaryIndexOptions === null || secondaryIndexOptions === void 0 ? void 0 : secondaryIndexOptions.length) {
                  _context12.next = 3;
                  break;
                }

                throw new _errors.GenericDataError("Invalid secondary index definitions");

              case 3:
                indexName = paramOption.indexName, partitionQuery = paramOption.partitionQuery, sortKeyQuery = paramOption.sortKeyQuery, fields = paramOption.fields, pagingParams = paramOption.pagingParams, otherQuery = paramOption.otherQuery;
                secondaryIndex = secondaryIndexOptions.find(function (item) {
                  return item.indexName === indexName;
                });

                if (secondaryIndex) {
                  _context12.next = 7;
                  break;
                }

                throw new _errors.GenericDataError("Secondary index not named/defined");

              case 7:
                keyFieldName = secondaryIndex.keyFieldName;
                sortFieldName = secondaryIndex.sortFieldName;
                partitionSortKeyQuery = sortKeyQuery ? _objectSpread(_objectSpread({}, _defineProperty({}, sortFieldName, sortKeyQuery)), _defineProperty({}, keyFieldName, partitionQuery.equals)) : _defineProperty({}, keyFieldName, partitionQuery.equals);
                _this$__helperDynamoF = this.__helperDynamoFilterOperation({
                  queryDefs: partitionSortKeyQuery,
                  projectionFields: fields !== null && fields !== void 0 ? fields : undefined
                }), expressionAttributeValues = _this$__helperDynamoF.expressionAttributeValues, filterExpression = _this$__helperDynamoF.filterExpression, projectionExpressionAttr = _this$__helperDynamoF.projectionExpressionAttr, expressionAttributeNames = _this$__helperDynamoF.expressionAttributeNames;
                otherFilterExpression = undefined;
                otherExpressionAttributeValues = undefined;
                otherExpressionAttributeNames = undefined;

                if (otherQuery) {
                  otherAttr = this.__helperDynamoFilterOperation({
                    queryDefs: otherQuery,
                    projectionFields: null
                  });
                  otherExpressionAttributeValues = otherAttr.expressionAttributeValues;
                  otherExpressionAttributeNames = otherAttr.expressionAttributeNames;

                  if ((otherAttr === null || otherAttr === void 0 ? void 0 : (_otherAttr$filterExpr = otherAttr.filterExpression) === null || _otherAttr$filterExpr === void 0 ? void 0 : _otherAttr$filterExpr.length) && (otherAttr === null || otherAttr === void 0 ? void 0 : otherAttr.filterExpression.length) > 1) {
                    otherFilterExpression = otherAttr.filterExpression;
                  }
                }

                params = {
                  TableName: tableFullName,
                  KeyConditionExpression: filterExpression,
                  ExpressionAttributeValues: _objectSpread(_objectSpread({}, otherExpressionAttributeValues), expressionAttributeValues),
                  FilterExpression: (_otherFilterExpressio2 = otherFilterExpression) !== null && _otherFilterExpressio2 !== void 0 ? _otherFilterExpressio2 : undefined,
                  ExpressionAttributeNames: _objectSpread(_objectSpread({}, otherExpressionAttributeNames), expressionAttributeNames)
                };
                orderDesc = (pagingParams === null || pagingParams === void 0 ? void 0 : pagingParams.orderDesc) === true;

                if (orderDesc) {
                  params.ScanIndexForward = false;
                }

                if (projectionExpressionAttr) {
                  params.ProjectionExpression = projectionExpressionAttr;
                }

                hashKeyName = secondaryIndex.keyFieldName;
                sortKeyName = secondaryIndex.sortFieldName;
                hashKeyAndSortKey = [hashKeyName, sortKeyName];
                _context12.next = 24;
                return this.__helperDynamoQueryProcessor(_objectSpread({
                  dynamoDbClient: function dynamoDbClient() {
                    return _this4._dynamoDbClient();
                  },
                  params: params,
                  orderDesc: orderDesc,
                  hashKeyAndSortKey: hashKeyAndSortKey
                }, pagingParams));

              case 24:
                result = _context12.sent;
                return _context12.abrupt("return", result);

              case 26:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function allQuerySecondaryIndexPaginateBase(_x12) {
        return _allQuerySecondaryIndexPaginateBase.apply(this, arguments);
      }

      return allQuerySecondaryIndexPaginateBase;
    }()
  }, {
    key: "allDeleteByIdBase",
    value: function () {
      var _allDeleteByIdBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(_ref14) {
        var _Key3;

        var dataId, _this$_getLocalVariab11, tableFullName, partitionKeyFieldName, sortKeyFieldName, dataExist, params;

        return regeneratorRuntime.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                dataId = _ref14.dataId;
                //
                this.allHelpValidateRequiredString({
                  Del1SortKey: dataId
                });
                _this$_getLocalVariab11 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab11.tableFullName, partitionKeyFieldName = _this$_getLocalVariab11.partitionKeyFieldName, sortKeyFieldName = _this$_getLocalVariab11.sortKeyFieldName;
                _context13.next = 5;
                return this.allDeleteByIdBase({
                  dataId: dataId
                });

              case 5:
                dataExist = _context13.sent;

                if (dataExist && dataExist[partitionKeyFieldName]) {
                  _context13.next = 8;
                  break;
                }

                throw new _errors.GenericDataError("Record does NOT exists");

              case 8:
                params = {
                  TableName: tableFullName,
                  Key: (_Key3 = {}, _defineProperty(_Key3, partitionKeyFieldName, dataId), _defineProperty(_Key3, sortKeyFieldName, sortKeyFieldName), _Key3)
                };
                _context13.next = 11;
                return this._dynamoDbClient()["delete"](params).promise();

              case 11:
                return _context13.abrupt("return", dataExist);

              case 12:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function allDeleteByIdBase(_x13) {
        return _allDeleteByIdBase.apply(this, arguments);
      }

      return allDeleteByIdBase;
    }()
  }, {
    key: "allDeleteManyDangerouselyByIds",
    value: function () {
      var _allDeleteManyDangerouselyByIds = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14(_ref15) {
        var _this5 = this;

        var dataIds, _this$_getLocalVariab12, tableFullName, partitionKeyFieldName, sortKeyFieldName, featureIdentityValue, delArray, params;

        return regeneratorRuntime.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                dataIds = _ref15.dataIds;
                //
                dataIds.forEach(function (sortKeyValue) {
                  _this5.allHelpValidateRequiredString({
                    DelSortKey: sortKeyValue
                  });
                });
                _this$_getLocalVariab12 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab12.tableFullName, partitionKeyFieldName = _this$_getLocalVariab12.partitionKeyFieldName, sortKeyFieldName = _this$_getLocalVariab12.sortKeyFieldName, featureIdentityValue = _this$_getLocalVariab12.featureIdentityValue;
                delArray = dataIds.map(function (dataId) {
                  var _Key4;

                  var params01 = {
                    DeleteRequest: {
                      Key: (_Key4 = {}, _defineProperty(_Key4, partitionKeyFieldName, {
                        S: dataId
                      }), _defineProperty(_Key4, sortKeyFieldName, {
                        S: featureIdentityValue
                      }), _Key4)
                    }
                  };
                  return params01;
                });
                params = {
                  RequestItems: _defineProperty({}, tableFullName, delArray)
                };
                _context14.next = 7;
                return this._dynamoDb().batchWriteItem(params).promise();

              case 7:
                return _context14.abrupt("return", true);

              case 8:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function allDeleteManyDangerouselyByIds(_x14) {
        return _allDeleteManyDangerouselyByIds.apply(this, arguments);
      }

      return allDeleteManyDangerouselyByIds;
    }()
  }]);

  return DynamoDataOperation;
}(_baseMixins["default"]);

exports.DynamoDataOperation = DynamoDataOperation;