import { ISecondaryIndexDef } from "../types";
import { DynamoDB } from "aws-sdk";
interface IDynamoOptions<T> {
    dynamoDb: () => DynamoDB;
    secondaryIndexOptions: ISecondaryIndexDef<T>[];
    tableFullName: string;
    partitionKeyFieldName: string;
    sortKeyFieldName: string;
}
export declare class DynamoManageTable<T> {
    private readonly partitionKeyFieldName;
    private readonly sortKeyFieldName;
    private readonly dynamoDb;
    private readonly tableFullName;
    private readonly secondaryIndexOptions;
    constructor({ dynamoDb, secondaryIndexOptions, tableFullName, partitionKeyFieldName, sortKeyFieldName, }: IDynamoOptions<T>);
    private _getLocalVariables;
    private _dynamoDb;
    allGetListOfTablesNamesOnlineBase(): Promise<DynamoDB.TableNameList | undefined>;
    allTableSettingUpdateTTLBase({ attrName, isEnabled, }: {
        attrName: keyof T;
        isEnabled: boolean;
    }): Promise<DynamoDB.TimeToLiveSpecification | null>;
    allGetTableInfoBase(): Promise<DynamoDB.TableDescription | null>;
    allCheckTableExistsBase(): Promise<boolean>;
    private _allUpdateGlobalSecondaryIndexBase;
    allCreateTableIfNotExistsBase(): Promise<DynamoDB.TableDescription | null>;
    private _getGlobalSecondaryIndexCreationParams;
    allCreateTableBase(): Promise<DynamoDB.TableDescription | null>;
    allDeleteGlobalSecondaryIndexBase(indexName: string): Promise<DynamoDB.TableDescription | null>;
}
export {};
